﻿using Microsoft.AspNetCore.Components;
using Microsoft.AspNetCore.Components.Rendering;
using Microsoft.AspNetCore.Components.Routing;
using Syncfusion.Blazor.Grids;
using System.Collections.Generic;
using System.Threading.Tasks;
using static DataGrid.Pages.Index;

namespace DataGrid.Pages
{
    public class Comp<T> : SfGrid<T>
    {
        public void OnToolbarClick(Syncfusion.Blazor.Navigations.ClickEventArgs args)
        {
            if (args.Item.Id == "Grid_excelexport")
            {
                this.GridRef.ExcelExport();
            }
        }
        private SfGrid<T> GridRef { get; set; }
        protected override void BuildRenderTree(RenderTreeBuilder builder)
        {            
            builder.OpenComponent<SfGrid<T>>(0);               
            builder.AddAttribute(1, nameof(AllowPaging), true);
            builder.AddAttribute(2, nameof(DataSource), DataSource);
            builder.AddAttribute(3, "ChildContent", new RenderFragment(inner =>
            {
                inner.OpenComponent<GridPageSettings>(5);
                inner.AddAttribute(6, nameof(GridPageSettings.PageSize), Microsoft.AspNetCore.Components.CompilerServices.RuntimeHelpers.TypeCheck<System.Int32>(10));
                inner.CloseComponent();

                inner.OpenComponent<GridEditSettings>(8);
                inner.AddAttribute(9,"AllowAdding",true);
                inner.AddAttribute(10, nameof(GridEditSettings.AllowDeleting), Microsoft.AspNetCore.Components.CompilerServices.RuntimeHelpers.TypeCheck<bool>(true));
                inner.AddAttribute(11, nameof(GridEditSettings.AllowEditing), Microsoft.AspNetCore.Components.CompilerServices.RuntimeHelpers.TypeCheck<System.Boolean>(true));
                inner.CloseComponent();

                inner.OpenComponent<GridColumns>(12);
                inner.AddAttribute(13, "ChildContent", (RenderFragment)((_builder1) =>
                {

                    _builder1.OpenComponent(14, typeof(Syncfusion.Blazor.Grids.GridColumn));
                    _builder1.AddAttribute(15, "Field", Microsoft.AspNetCore.Components.CompilerServices.RuntimeHelpers.TypeCheck<System.String>("OrderID"));
                    _builder1.AddAttribute(16, "IsPrimaryKey", Microsoft.AspNetCore.Components.CompilerServices.RuntimeHelpers.TypeCheck<System.Boolean>(true));
                    _builder1.CloseComponent();
                    _builder1.AddMarkupContent(17, "\r\n");

                    _builder1.OpenComponent(18, typeof(Syncfusion.Blazor.Grids.GridColumn));
                    _builder1.AddAttribute(19, "Field", Microsoft.AspNetCore.Components.CompilerServices.RuntimeHelpers.TypeCheck<System.String>("OrderDate"));
                    _builder1.CloseComponent();
                    _builder1.AddMarkupContent(21, "\r\n");

                    _builder1.OpenComponent(22, typeof(Syncfusion.Blazor.Grids.GridColumn));
                    _builder1.AddAttribute(23, "Field", Microsoft.AspNetCore.Components.CompilerServices.RuntimeHelpers.TypeCheck<System.String>("Freight"));
                    _builder1.CloseComponent();
                    _builder1.AddMarkupContent(25, "\r\n");
                    
                    _builder1.OpenComponent(26, typeof(Syncfusion.Blazor.Grids.GridColumn));
                    _builder1.AddAttribute(27, "Field", Microsoft.AspNetCore.Components.CompilerServices.RuntimeHelpers.TypeCheck<System.String>("CustomerID"));
                    _builder1.AddAttribute(28, "EditTemplate", (Microsoft.AspNetCore.Components.RenderFragment<System.Object>)((context) => (_builder2) =>
                    {
                        _builder2.AddMarkupContent(29, "\r\n                ");
                        _builder2.OpenComponent<Syncfusion.Blazor.DropDowns.SfDropDownList<string, Order>>(30);
                        _builder2.AddAttribute(31, "ID", "CustomerID");
                        _builder2.AddAttribute(32, "DataSource", Microsoft.AspNetCore.Components.CompilerServices.RuntimeHelpers.TypeCheck<System.Collections.Generic.IEnumerable<Order>>(
                            (IEnumerable<Order>)DataSource
                            ));
                        _builder2.AddAttribute(33, "Value", Microsoft.AspNetCore.Components.CompilerServices.RuntimeHelpers.TypeCheck<string>(
                            (context as Order).CustomerID));
                        _builder2.AddAttribute(34, "ValueChanged", Microsoft.AspNetCore.Components.CompilerServices.RuntimeHelpers.TypeCheck<Microsoft.AspNetCore.Components.EventCallback<string>>(Microsoft.AspNetCore.Components.EventCallback.Factory.Create<string>(this, Microsoft.AspNetCore.Components.CompilerServices.RuntimeHelpers.CreateInferredEventCallback(this, __value => (context as Order).CustomerID = __value, (context as Order).CustomerID))));
                        _builder2.AddAttribute(35, "ValueExpression",  Microsoft.AspNetCore.Components.CompilerServices.RuntimeHelpers.TypeCheck<System.Linq.Expressions.Expression<System.Func<string>>>(() => (context as Order).CustomerID));
                        _builder2.AddAttribute(36, "ChildContent", (Microsoft.AspNetCore.Components.RenderFragment)((_builder3) => {
                            _builder3.AddMarkupContent(37, "\r\n                    ");
                            _builder3.OpenComponent<Syncfusion.Blazor.DropDowns.DropDownListFieldSettings>(38);
                            _builder3.AddAttribute(39, "Value", "CustomerID");
                            _builder3.CloseComponent();
                            _builder3.AddMarkupContent(40, "\r\n                ");
                        }));
                        _builder2.CloseComponent();
                        _builder2.AddMarkupContent(41, "\r\n            ");
                    }));
                    _builder1.CloseComponent();
                    _builder1.AddMarkupContent(42, "\r\n");


                }));
                inner.CloseComponent();

                inner.OpenComponent<GridEvents<T>>(43);
                inner.AddAttribute<Syncfusion.Blazor.Navigations.ClickEventArgs>(44, "OnToolbarClick",
                    EventCallback.Factory.Create<Syncfusion.Blazor.Navigations.ClickEventArgs>(this, OnToolbarClick));
                inner.CloseComponent();

            }));
            builder.AddAttribute(45, nameof(Toolbar), new List<string>() {"Add", "Edit", "Cancel", "Update", "ExcelExport" });
            builder.AddAttribute(46, nameof(AllowExcelExport), true);
            builder.AddAttribute(47, nameof(ID), "Grid");
            builder.AddComponentReferenceCapture(48, inst => { GridRef = (SfGrid<T>)inst; });
            builder.CloseComponent();
        }
    }
}
